/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.stimmzettel.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatum;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractStimmzettelKopfdatumSearch {

  @Inject
  protected transient StimmzettelKopfdatumExtendedDAO dao;

  public AbstractStimmzettelKopfdatumSearch() {
    super();
  }

  public List<StimmzettelKopfdatum> getSearchResult(StimmzettelKopfdatumSearchParameters searchParameters, EagerLoadingCollector<StimmzettelKopfdatum> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<StimmzettelKopfdatum> querySearchResult(StimmzettelKopfdatumSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
